filename = '../human_coarse.off';
[X,T] = readOff(filename);
nv = size(X,1);
nt = size(T,1);
mesh = getMeshData(X,T);

%% Compute 10 eigenfunctions and display eigenfunction 4
k = 10;
[vals, vecs] = laplacianSpectrum(X,T,k);
showDescriptor(mesh,vecs(:,4));

%% Plot HKS on hands and knees of mesh
k = 300;
nSamples = 500;

[vals,vecs] = laplacianSpectrum(X,T,k);
heatSignature = HKS(vals,vecs,nSamples);

hand1 = 259;
hand2 = 135;
knee1 = 232;
knee2 = 257;

x = 1:nSamples;
f = figure;
subplot(2,2,1);
scatter(x,heatSignature(hand1,:),5);
subplot(2,2,2);
scatter(x,heatSignature(hand2,:),5);
subplot(2,2,3);
scatter(x,heatSignature(knee1,:),5);
subplot(2,2,4);
scatter(x,heatSignature(knee2,:),5);

%% COMPUTE DIFFERENCE FUNCTION |HKS(x0) - HKS(x)|_2 HERE ###
result = zeros(nv,1);
showDescriptor(mesh,result);

%% COMPLETE THE FUNCTIONS BELOW
function [eigenvalues,eigenvectors] = laplacianSpectrum(X,T,k)
nv = size(X,1);   
eigenvalues = zeros(nv,1);
eigenvectors = zeros(nv,k);
end

function heatSignature = HKS(eigenvalues,eigenvectors,nSamples)
neig = size(eigenvalues,1);

tmin = -4*log(10)/eigenvalues(end);
tmax = -4*log(10)/eigenvalues(2);
ts = logspace(log10(tmin),log10(tmax),nSamples);

heatSignature = zeros(size(eigenvectors,1),nSamples);
end